const sequelize = require('../db');
const {Sequelize} = require('sequelize');

const Enterprise = sequelize.define('enterprise', {
    name: {
        type: Sequelize.STRING, // название предприятия
        allowNull: false
    },
    resourceType: {
        type: Sequelize.STRING, // тип ресурса (дерево, металл и т.д.)
        allowNull: false
    },
    level: {
        type: Sequelize.INTEGER, // уровень предприятия
        defaultValue: 1
    },
    efficiency: {
        type: Sequelize.INTEGER, // производительность в час (единицы ресурса)
        defaultValue: 10 // начальная эффективность
    },
    warehouseCapacity: {
        type: Sequelize.INTEGER, // ёмкость склада (максимальное количество ресурса)
        defaultValue: 100
    },
    playerId: {
        type: Sequelize.INTEGER, 
        references: {
            model: 'Users',
            key: 'telegram_id'
        }
    }
});

module.exports = Enterprise;
