const sequelize = require('../db');
const {Sequelize} = require('sequelize');

const Sale = sequelize.define('sale', {
    enterpriseId: {
        type: Sequelize.INTEGER, 
        references: {
            model: 'Enterprises',
            key: 'id'
        }
    },
    resourceType: {
        type: Sequelize.STRING, // тип ресурса
        allowNull: false
    },
    quantity: {
        type: Sequelize.INTEGER, // количество продаваемого ресурса
        defaultValue: 0
    },
    salePrice: {
        type: Sequelize.FLOAT, // цена за единицу ресурса
        defaultValue: 100
    },
    time: {
        type: Sequelize.DATE, // время продажи
        defaultValue: Sequelize.NOW
    }
});


module.exports = Sale;
