const sequelize = require('../db');
const {Sequelize} = require('sequelize');

const Warehouse = sequelize.define('warehouse', {
    playerId: {
        type: Sequelize.INTEGER, 
        references: {
            model: 'Users',
            key: 'id'
        }
    },
    capacity: {
        type: Sequelize.INTEGER, // ёмкость общего склада
        defaultValue: 500
    },
    logisticsLevel: {
        type: Sequelize.INTEGER, // уровень логистики
        defaultValue: 1
    }
});

const Truck = sequelize.define('truck', {
    warehouseId: {
        type: Sequelize.INTEGER, 
        references: {
            model: 'Warehouses',
            key: 'id'
        }
    },
    capacity: {
        type: Sequelize.INTEGER, // сколько ресурсов грузовик может вывозить в час
        defaultValue: 10
    },
    efficiency: {
        type: Sequelize.INTEGER, // эффективность грузовика (на сколько быстрее он может работать)
        defaultValue: 1
    }
});

module.exports = Warehouse, Truck;
